<!--
  - Copyright (C) 2021-2023 The Hunter2 Contributors.
  -
  - This file is part of Hunter2.
  -
  - Hunter2 is free software: you can redistribute it and/or modify it under the terms of the GNU Affero General Public License as published by the Free
  - Software Foundation, either version 3 of the License, or (at your option) any later version.
  -
  - Hunter2 is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A
  - PARTICULAR PURPOSE.  See the GNU Affero General Public License for more details.
  -
  - You should have received a copy of the GNU Affero General Public License along with Hunter2.  If not, see <http://www.gnu.org/licenses/>.
  -->
<template>
  <div class="team_puzzles_admin_widget">
    <h3>Started Puzzles: {{ puzzles.length }}</h3>
    <ul id="started-puzzles-widget">
      <div
        v-for="puzzle in sortedPuzzles"
        :id="'puzzle-' + puzzle.id"
        :key="puzzle.id"
        class="card"
      >
        <div class="card-header">
          <a
            v-if="puzzle.reset_url"
            :href="puzzle.reset_url"
            title="Reset progress on this puzzle"
            class="btn btn-danger header-link reset-button"
          >↺</a>
          <a class="header-link" :href="puzzle.edit_url">edit</a>
          <a class="header-link" :href="puzzle.url">view</a>
          <div
            class="started-puzzle-header text-center collapsed"
            role="button"
            data-bs-toggle="collapse"
            :data-bs-target="`#puzzle-${puzzle.id}-detail`"
            aria-expanded="false"
            :aria-controls="`puzzle-${puzzle.id}-detail`"
          >
            <h4>{{ puzzle.episode_name }}: {{ puzzle.title }}</h4>
            <div>
              <b>Total guesses:</b> {{ puzzle.num_guesses }} &emsp;
              <b>Started puzzle:</b> <human-datetime :value="puzzle.time_started" /> &emsp;
              <b>Latest guess:</b> <human-datetime :value="puzzle.latest_guess_time" /> &emsp;
              <b>Unlocks received:</b> {{ puzzle.clues_visible.length }}&emsp;
              <b>Hints scheduled:</b> {{ puzzle.hints_scheduled.length }}
            </div>
          </div>
        </div>
        <div
          :id="`puzzle-${puzzle.id}-detail`"
          class="card-body collapse"
        >
          <h5>Clues Visible</h5>
          <table class="table table-sm table-striped team-admin-clues">
            <thead>
              <tr>
                <th scope="col">
                  Type
                </th>
                <th scope="col">
                  Text
                </th>
                <th scope="col" title="for hints: received or, if accepted, accepted">
                  Received At
                </th>
              </tr>
            </thead>
            <tbody>
              <tr
                v-for="clue in puzzle.clues_visible"
                :key="clue.key"
              >
                <td>{{ clue.type }}</td>
                <!-- This can be HTML but it'll be written to render in the context of the puzzle page,
                             so it's better to just show the source than try to render it here -->
                <td :class="((clue.type === 'Hint') && !clue.accepted) ? 'clue-unaccepted' : 'clue'">
                  <span :class="clue.type" />
                  <span :class="(clue.type === 'Hint').toString()" />
                  <span :class="((clue.type === 'Hint') && !clue.accepted).toString()" />
                  {{ clue.text }}
                </td>
                <td><human-datetime :value="clue.time" /></td>
              </tr>
            </tbody>
          </table>
          <template v-if="puzzle.hints_scheduled.length > 0">
            <h5>Timed Hints Scheduled</h5>
            <ol class="hints">
              <li
                v-for="hint in puzzle.hints_scheduled"
                :key="hint.key"
              >
                <human-datetime :value="hint.time" :title="hint.text" />
              </li>
            </ol>
          </template>
          <template v-else>
            <h5>No Timed Hints Scheduled</h5>
          </template>
          <h5>
            Recent Guesses <a
              class="header-link"
              :href="puzzle.guesses_url"
            >more</a>
          </h5>
          <table class="table table-sm table-striped">
            <thead>
              <tr>
                <th scope="col">
                  User
                </th>
                <th scope="col">
                  Guess
                </th>
                <th scope="col">
                  Given
                </th>
              </tr>
            </thead>
            <tbody>
              <tr
                v-for="guess in puzzle.guesses"
                :key="guess.key"
              >
                <td>{{ guess.user }}</td>
                <td>{{ guess.guess }}</td>
                <td><human-datetime :value="guess.given" /></td>
              </tr>
            </tbody>
          </table>
        </div>
      </div>
    </ul>
    <h3>Solved Puzzles: {{ solved_puzzles.length }}</h3>
    <ul class="d-flex flex-wrap">
      <div
        v-for="puzzle in solved_puzzles"
        :id="'puzzle-' + puzzle.id"
        :key="puzzle.id"
        class="card solved-puzzle"
      >
        <h4 class="card-header">
          {{ puzzle.title }}
          <a
            v-if="puzzle.reset_url"
            :href="puzzle.reset_url"
            title="Reset progress on this puzzle"
            class="btn btn-danger reset-button"
          >↺</a>
        </h4>
        <span class="card-body">
          After <human-duration :value="puzzle.time_taken" /> with {{ puzzle.num_guesses }} guesses.
        </span>
      </div>
    </ul>
  </div>
</template>
<script>
import URI from 'urijs'
import 'bootstrap/js/dist/button'
import 'bootstrap/js/dist/collapse'

import HumanDateTime from '../human-datetime.vue'
import HumanDuration from '../human-duration.vue'

export default {
  components: {
    'human-datetime': HumanDateTime,
    'human-duration': HumanDuration,
  },
  props: {
    href: {
      required: true,
      type: String,
    },
  },
  data () {
    return {
      puzzles: [],
      solved_puzzles: [],
      'guess_fields': [
        'user',
        'guess',
        'given',
      ],
      'clue_fields': [
        'type',
        'text',
        'time',
      ],
    }
  },
  computed: {
    sortedPuzzles() {
      function comparePuzzles(a, b) {
        const ad = new Date(a.latest_guess_time)
        const bd = new Date(b.latest_guess_time)
        return bd - ad
      }
      return [...this.puzzles].sort(comparePuzzles)
    },
  },
  created: function() {
    this.updateData(true)
  },
  methods: {
    anchor: function() { return window.location.hash.substring(1) },
    updateData: function(force) {
      clearTimeout(this.timer)
      if (force || this.autoUpdate) {
        let url = URI(this.href)
        let v = this
        fetch(url).then(
          response => response.json(),
        ).then(
          data => {
            v.puzzles = data.puzzles
            v.solved_puzzles = data.solved_puzzles
          },
        )
        if (this.autoUpdate) {
          this.timer = setTimeout(this.updateData, 5000)
        }
      }
    },
  },
}
</script>
<style lang="scss" scoped>
ol.hints {
    list-style: none;

    > li {
        display: inline;
        text-decoration: dashed underline;
    }

    > li:not(:last-child):after {
        content: ", ";
    }
}

.header-link {
    float: right;
    margin: 3pt;
}

.expandable-indicator {
    float: left;
    font-weight: bold;
    font-size: 200%;
    line-height: 75%;
    vertical-align: top;
}

.started-puzzle-header {
    &.collapsed::before {
        @extend .expandable-indicator;
        content: "+";
    }

    &:not(.collapsed)::before {
        @extend .expandable-indicator;
        content: "\2212"; /* Minus Sign */
    }
}

.reset-button {
    float: right;
    margin-left: 1em;
    text-align: center;
    border-radius: 50%;
    padding: 0;
    width: 1.2em;
    height: 1.2em;
    line-height: 1.2em;
    font-size: 1.5rem;
}

table.team-admin-clues {
    td.clue-unaccepted {
        color: #ffffff33;
    }
    tr:nth-of-type(2n+1) > td.clue-unaccepted {
        color: #cfcfcf33;
    }
}
</style>
